//$Id: LoginAction.java,v 1.16 2006/10/12 02:49:35 gavin Exp $
package org.jboss.seam.example.booking;

import java.util.List;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.contexts.Contexts;
import org.jboss.seam.core.FacesMessages;
import org.jboss.security.saml.SSOUser;

@Stateless
@Name("login")
public class LoginAction implements Login
{
   
   private User user;
   
   //jboss-sso integration
   String username = "";
   String password = "";

   public String getUserName() {
       return username;
   }
   public void setUserName(String username) {
       this.username = username;
   }

   public String getPassword() {
       return password;
   }
   public void setPassword(String password) {
       this.password = password;
   }
   
   
   
   @PersistenceContext
   private EntityManager em;

   public String login()
   {
      List<User> results = em.createQuery("select u from User u where u.username=:username and u.password=:password")
            .setParameter("username", username)
            .setParameter("password", password)
            .getResultList();
      
      if ( results.size()==0 )
      {
         FacesMessages.instance().add("Invalid login");
         return "login";
      }
      else
      {
         user = results.get(0);
         Contexts.getSessionContext().set("loggedIn", true);
         Contexts.getSessionContext().set("user",user);
         FacesMessages.instance().add("Welcome, #{user.name}");
         
         //jboss-sso integration
         SSOUser ssoUser = new SSOUser(user.getUsername(),null);
         Contexts.getSessionContext().set("jboss_sso_user",ssoUser);
         
         return "main";
      }
      
   }
   
   //jboss-sso integration
   public boolean isLoggedIn()
   {
       boolean isLoggedIn = false;
       
       if(Contexts.getSessionContext().get("loggedIn")==null)
       {
           if(Contexts.getSessionContext().get("jboss_sso_user")!=null)
           {
               SSOUser ssoUser = (SSOUser)Contexts.getSessionContext().get("jboss_sso_user");
               
               List<User> results = em.createQuery("select u from User u where u.username=:username")
               .setParameter("username", ssoUser.getUserName())             
               .getResultList();
               
               if(results.size()!=0)
               {
                   user = results.get(0);
                   
                   Contexts.getSessionContext().set("loggedIn", true);
                   Contexts.getSessionContext().set("user",user);
                   FacesMessages.instance().add("Welcome, #{user.name}");
                   
                   isLoggedIn = true;
                   
               }
           }
       }
       else
       {
           isLoggedIn = true;
       }
       
       return isLoggedIn;
   }
   
   public String getMoviePartner()
   {
       //return "http://dvd.jboss.com:8080/seam-dvd/browse.seam?refresh=1";
       return "http://dvd.jboss.com:8080/seam-dvd/browse.seam?refresh=1";
   }
}
