/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package com.jboss.dvd.sso;


import javax.servlet.http.HttpServletRequest;

import java.security.Principal;
import java.util.Collection;
import java.util.Properties;

import org.jboss.security.idm.Identity;
import org.jboss.security.idm.IdentityException;
import org.jboss.security.idm.LoginContext;
import org.jboss.security.idm.LoginProvider;
import org.jboss.security.saml.SSOUser;


/**
 * 
 * @author Sohil Shah - sohil.shah@jboss.com - Nov 15, 2006
 *
 */
public class StubLoginProvider implements LoginProvider 
{
    private String id = null;
    
    
    public StubLoginProvider() 
    {
        super();
    }

    public String getId() 
    throws IdentityException 
    {        
        return this.id;
    }
    
    public void setId(String id)
    {
        this.id = id;
    }
    
    public void setProperties(Properties properties)
    {
        
    }

    public Identity read(Principal arg0) 
    throws IdentityException 
    {        
        return null;
    }

    public Identity read(String arg0) throws IdentityException 
    {
        return null;
    }

    public boolean exists(Principal arg0) 
    throws IdentityException 
    {        
        return this.exists(arg0.getName());
    }

    public boolean exists(String arg0) throws IdentityException 
    {
        return true;
    }

    public boolean login(Principal arg0, byte[] arg1) throws IdentityException 
    {
        return false;
    }

    public boolean login(String arg0, byte[] arg1) throws IdentityException 
    {
        return false;
    }

    public Collection readAllRoles() throws IdentityException 
    {
        return null;
    }
    
    /**
     * This notification is received from the SSO Engine when the engine performs an automatic logic based 
     * on a trusted assertion received from a partner site. The method can be used by the application to setup its
     * environment in response to the user logged in to the system
     * 
     * @param loginContext
     * @throws IdentityException
     */
    public void processSSOLoginNotification(LoginContext loginContext) throws IdentityException
    {        
    }
}
